<?php
/**
 * InlineResponse20081ContentAllOfAllOf
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20081ContentAllOfAllOf Class Doc Comment
 *
 * @category Class
 * @description Describes a periphery
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20081ContentAllOfAllOf implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_81_content_allOf_allOf';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'companyId' => 'int',
        'date' => 'int',
        'peripheryTypeId' => 'int',
        'manufacturerId' => 'int',
        'type' => 'string',
        'location' => 'string',
        'remark' => 'string',
        'internalRemark' => 'string',
        'serialNumber' => 'string',
        'inventoryNumber' => 'string',
        'version' => 'string',
        'active' => 'bool',
        'employeeId' => 'int',
        'pcId' => 'int',
        'billingNumber' => 'string',
        'articleNumber' => 'string',
        'storageId' => 'int',
        'purchasePrice' => 'float',
        'sellingPrice' => 'float',
        'ownageType' => 'string',
        'name' => 'string',
        'description' => 'string',
        'manufacturerNumber' => 'string',
        'fields' => '\SLIS\Adapter\Tanss\Model\InlineResponse20079ContentAllOfDevicesItemsFieldsInner[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'companyId' => null,
        'date' => 'timestamp',
        'peripheryTypeId' => null,
        'manufacturerId' => null,
        'type' => null,
        'location' => null,
        'remark' => null,
        'internalRemark' => null,
        'serialNumber' => null,
        'inventoryNumber' => null,
        'version' => null,
        'active' => null,
        'employeeId' => null,
        'pcId' => null,
        'billingNumber' => null,
        'articleNumber' => null,
        'storageId' => null,
        'purchasePrice' => null,
        'sellingPrice' => null,
        'ownageType' => null,
        'name' => null,
        'description' => null,
        'manufacturerNumber' => null,
        'fields' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'companyId' => 'companyId',
        'date' => 'date',
        'peripheryTypeId' => 'peripheryTypeId',
        'manufacturerId' => 'manufacturerId',
        'type' => 'type',
        'location' => 'location',
        'remark' => 'remark',
        'internalRemark' => 'internalRemark',
        'serialNumber' => 'serialNumber',
        'inventoryNumber' => 'inventoryNumber',
        'version' => 'version',
        'active' => 'active',
        'employeeId' => 'employeeId',
        'pcId' => 'pcId',
        'billingNumber' => 'billingNumber',
        'articleNumber' => 'articleNumber',
        'storageId' => 'storageId',
        'purchasePrice' => 'purchasePrice',
        'sellingPrice' => 'sellingPrice',
        'ownageType' => 'ownageType',
        'name' => 'name',
        'description' => 'description',
        'manufacturerNumber' => 'manufacturerNumber',
        'fields' => 'fields'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'companyId' => 'setCompanyId',
        'date' => 'setDate',
        'peripheryTypeId' => 'setPeripheryTypeId',
        'manufacturerId' => 'setManufacturerId',
        'type' => 'setType',
        'location' => 'setLocation',
        'remark' => 'setRemark',
        'internalRemark' => 'setInternalRemark',
        'serialNumber' => 'setSerialNumber',
        'inventoryNumber' => 'setInventoryNumber',
        'version' => 'setVersion',
        'active' => 'setActive',
        'employeeId' => 'setEmployeeId',
        'pcId' => 'setPcId',
        'billingNumber' => 'setBillingNumber',
        'articleNumber' => 'setArticleNumber',
        'storageId' => 'setStorageId',
        'purchasePrice' => 'setPurchasePrice',
        'sellingPrice' => 'setSellingPrice',
        'ownageType' => 'setOwnageType',
        'name' => 'setName',
        'description' => 'setDescription',
        'manufacturerNumber' => 'setManufacturerNumber',
        'fields' => 'setFields'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'companyId' => 'getCompanyId',
        'date' => 'getDate',
        'peripheryTypeId' => 'getPeripheryTypeId',
        'manufacturerId' => 'getManufacturerId',
        'type' => 'getType',
        'location' => 'getLocation',
        'remark' => 'getRemark',
        'internalRemark' => 'getInternalRemark',
        'serialNumber' => 'getSerialNumber',
        'inventoryNumber' => 'getInventoryNumber',
        'version' => 'getVersion',
        'active' => 'getActive',
        'employeeId' => 'getEmployeeId',
        'pcId' => 'getPcId',
        'billingNumber' => 'getBillingNumber',
        'articleNumber' => 'getArticleNumber',
        'storageId' => 'getStorageId',
        'purchasePrice' => 'getPurchasePrice',
        'sellingPrice' => 'getSellingPrice',
        'ownageType' => 'getOwnageType',
        'name' => 'getName',
        'description' => 'getDescription',
        'manufacturerNumber' => 'getManufacturerNumber',
        'fields' => 'getFields'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const OWNAGE_TYPE_OWN = 'OWN';
    public const OWNAGE_TYPE_FOREIGN = 'FOREIGN';
    public const OWNAGE_TYPE_OWN_RENT = 'OWN_RENT';
    public const OWNAGE_TYPE_FOREIGN_RENT = 'FOREIGN_RENT';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getOwnageTypeAllowableValues()
    {
        return [
            self::OWNAGE_TYPE_OWN,
            self::OWNAGE_TYPE_FOREIGN,
            self::OWNAGE_TYPE_OWN_RENT,
            self::OWNAGE_TYPE_FOREIGN_RENT,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['companyId'] = $data['companyId'] ?? null;
        $this->container['date'] = $data['date'] ?? null;
        $this->container['peripheryTypeId'] = $data['peripheryTypeId'] ?? null;
        $this->container['manufacturerId'] = $data['manufacturerId'] ?? null;
        $this->container['type'] = $data['type'] ?? null;
        $this->container['location'] = $data['location'] ?? null;
        $this->container['remark'] = $data['remark'] ?? null;
        $this->container['internalRemark'] = $data['internalRemark'] ?? null;
        $this->container['serialNumber'] = $data['serialNumber'] ?? null;
        $this->container['inventoryNumber'] = $data['inventoryNumber'] ?? null;
        $this->container['version'] = $data['version'] ?? null;
        $this->container['active'] = $data['active'] ?? null;
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['pcId'] = $data['pcId'] ?? null;
        $this->container['billingNumber'] = $data['billingNumber'] ?? null;
        $this->container['articleNumber'] = $data['articleNumber'] ?? null;
        $this->container['storageId'] = $data['storageId'] ?? null;
        $this->container['purchasePrice'] = $data['purchasePrice'] ?? null;
        $this->container['sellingPrice'] = $data['sellingPrice'] ?? null;
        $this->container['ownageType'] = $data['ownageType'] ?? null;
        $this->container['name'] = $data['name'] ?? null;
        $this->container['description'] = $data['description'] ?? null;
        $this->container['manufacturerNumber'] = $data['manufacturerNumber'] ?? null;
        $this->container['fields'] = $data['fields'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getOwnageTypeAllowableValues();
        if (!is_null($this->container['ownageType']) && !in_array($this->container['ownageType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'ownageType', must be one of '%s'",
                $this->container['ownageType'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of the periphery
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets companyId
     *
     * @return int|null
     */
    public function getCompanyId()
    {
        return $this->container['companyId'];
    }

    /**
     * Sets companyId
     *
     * @param int|null $companyId id of the assigned company
     *
     * @return self
     */
    public function setCompanyId($companyId)
    {
        $this->container['companyId'] = $companyId;

        return $this;
    }

    /**
     * Gets date
     *
     * @return int|null
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param int|null $date date when the device was purchased (or entered into the system)
     *
     * @return self
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets peripheryTypeId
     *
     * @return int|null
     */
    public function getPeripheryTypeId()
    {
        return $this->container['peripheryTypeId'];
    }

    /**
     * Sets peripheryTypeId
     *
     * @param int|null $peripheryTypeId id of the periphery type
     *
     * @return self
     */
    public function setPeripheryTypeId($peripheryTypeId)
    {
        $this->container['peripheryTypeId'] = $peripheryTypeId;

        return $this;
    }

    /**
     * Gets manufacturerId
     *
     * @return int|null
     */
    public function getManufacturerId()
    {
        return $this->container['manufacturerId'];
    }

    /**
     * Sets manufacturerId
     *
     * @param int|null $manufacturerId id of the device manufacturer
     *
     * @return self
     */
    public function setManufacturerId($manufacturerId)
    {
        $this->container['manufacturerId'] = $manufacturerId;

        return $this;
    }

    /**
     * Gets type
     *
     * @return string|null
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param string|null $type type of the periphery. This is mostly used to \"describe\" the periphery in lists
     *
     * @return self
     */
    public function setType($type)
    {
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets location
     *
     * @return string|null
     */
    public function getLocation()
    {
        return $this->container['location'];
    }

    /**
     * Sets location
     *
     * @param string|null $location location / room of this device
     *
     * @return self
     */
    public function setLocation($location)
    {
        $this->container['location'] = $location;

        return $this;
    }

    /**
     * Gets remark
     *
     * @return string|null
     */
    public function getRemark()
    {
        return $this->container['remark'];
    }

    /**
     * Sets remark
     *
     * @param string|null $remark remarks for this component
     *
     * @return self
     */
    public function setRemark($remark)
    {
        $this->container['remark'] = $remark;

        return $this;
    }

    /**
     * Gets internalRemark
     *
     * @return string|null
     */
    public function getInternalRemark()
    {
        return $this->container['internalRemark'];
    }

    /**
     * Sets internalRemark
     *
     * @param string|null $internalRemark internal remarks of the device (can contain passwords), which only is seen by technicians or freelancers with the given permission
     *
     * @return self
     */
    public function setInternalRemark($internalRemark)
    {
        $this->container['internalRemark'] = $internalRemark;

        return $this;
    }

    /**
     * Gets serialNumber
     *
     * @return string|null
     */
    public function getSerialNumber()
    {
        return $this->container['serialNumber'];
    }

    /**
     * Sets serialNumber
     *
     * @param string|null $serialNumber serial number of the device
     *
     * @return self
     */
    public function setSerialNumber($serialNumber)
    {
        $this->container['serialNumber'] = $serialNumber;

        return $this;
    }

    /**
     * Gets inventoryNumber
     *
     * @return string|null
     */
    public function getInventoryNumber()
    {
        return $this->container['inventoryNumber'];
    }

    /**
     * Sets inventoryNumber
     *
     * @param string|null $inventoryNumber inventory number of this device
     *
     * @return self
     */
    public function setInventoryNumber($inventoryNumber)
    {
        $this->container['inventoryNumber'] = $inventoryNumber;

        return $this;
    }

    /**
     * Gets version
     *
     * @return string|null
     */
    public function getVersion()
    {
        return $this->container['version'];
    }

    /**
     * Sets version
     *
     * @param string|null $version infos of the version of this device
     *
     * @return self
     */
    public function setVersion($version)
    {
        $this->container['version'] = $version;

        return $this;
    }

    /**
     * Gets active
     *
     * @return bool|null
     */
    public function getActive()
    {
        return $this->container['active'];
    }

    /**
     * Sets active
     *
     * @param bool|null $active true, if the device is active
     *
     * @return self
     */
    public function setActive($active)
    {
        $this->container['active'] = $active;

        return $this;
    }

    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId id of the assigned employee
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets pcId
     *
     * @return int|null
     */
    public function getPcId()
    {
        return $this->container['pcId'];
    }

    /**
     * Sets pcId
     *
     * @param int|null $pcId if the device is built into this pc, a pc id is given here
     *
     * @return self
     */
    public function setPcId($pcId)
    {
        $this->container['pcId'] = $pcId;

        return $this;
    }

    /**
     * Gets billingNumber
     *
     * @return string|null
     */
    public function getBillingNumber()
    {
        return $this->container['billingNumber'];
    }

    /**
     * Sets billingNumber
     *
     * @param string|null $billingNumber infos about the billing number which this component was purchased
     *
     * @return self
     */
    public function setBillingNumber($billingNumber)
    {
        $this->container['billingNumber'] = $billingNumber;

        return $this;
    }

    /**
     * Gets articleNumber
     *
     * @return string|null
     */
    public function getArticleNumber()
    {
        return $this->container['articleNumber'];
    }

    /**
     * Sets articleNumber
     *
     * @param string|null $articleNumber article number of the component
     *
     * @return self
     */
    public function setArticleNumber($articleNumber)
    {
        $this->container['articleNumber'] = $articleNumber;

        return $this;
    }

    /**
     * Gets storageId
     *
     * @return int|null
     */
    public function getStorageId()
    {
        return $this->container['storageId'];
    }

    /**
     * Sets storageId
     *
     * @param int|null $storageId id of the storage, the component is contained in
     *
     * @return self
     */
    public function setStorageId($storageId)
    {
        $this->container['storageId'] = $storageId;

        return $this;
    }

    /**
     * Gets purchasePrice
     *
     * @return float|null
     */
    public function getPurchasePrice()
    {
        return $this->container['purchasePrice'];
    }

    /**
     * Sets purchasePrice
     *
     * @param float|null $purchasePrice purchase price of this component
     *
     * @return self
     */
    public function setPurchasePrice($purchasePrice)
    {
        $this->container['purchasePrice'] = $purchasePrice;

        return $this;
    }

    /**
     * Gets sellingPrice
     *
     * @return float|null
     */
    public function getSellingPrice()
    {
        return $this->container['sellingPrice'];
    }

    /**
     * Sets sellingPrice
     *
     * @param float|null $sellingPrice selling price of this device
     *
     * @return self
     */
    public function setSellingPrice($sellingPrice)
    {
        $this->container['sellingPrice'] = $sellingPrice;

        return $this;
    }

    /**
     * Gets ownageType
     *
     * @return string|null
     */
    public function getOwnageType()
    {
        return $this->container['ownageType'];
    }

    /**
     * Sets ownageType
     *
     * @param string|null $ownageType describes who \"owns\" this pc
     *
     * @return self
     */
    public function setOwnageType($ownageType)
    {
        $allowedValues = $this->getOwnageTypeAllowableValues();
        if (!is_null($ownageType) && !in_array($ownageType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'ownageType', must be one of '%s'",
                    $ownageType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['ownageType'] = $ownageType;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name hostname
     *
     * @return self
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets description
     *
     * @return string|null
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     *
     * @param string|null $description misc. description infos for this device
     *
     * @return self
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets manufacturerNumber
     *
     * @return string|null
     */
    public function getManufacturerNumber()
    {
        return $this->container['manufacturerNumber'];
    }

    /**
     * Sets manufacturerNumber
     *
     * @param string|null $manufacturerNumber manufacturer number of this device
     *
     * @return self
     */
    public function setManufacturerNumber($manufacturerNumber)
    {
        $this->container['manufacturerNumber'] = $manufacturerNumber;

        return $this;
    }

    /**
     * Gets fields
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20079ContentAllOfDevicesItemsFieldsInner[]|null
     */
    public function getFields()
    {
        return $this->container['fields'];
    }

    /**
     * Sets fields
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20079ContentAllOfDevicesItemsFieldsInner[]|null $fields fields
     *
     * @return self
     */
    public function setFields($fields)
    {
        $this->container['fields'] = $fields;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


